| OpendTect 8.0

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Protected Attributes | Private Member Functions | Static Private Member Functions | Friends | List of all members
visBase::Coordinates Class Reference
visBase

A set of coordinates. The coordinates will be transformed by the transformation before given to Coin, and transformed back when doing a getPos. More...

`#include <viscoord.h>`

Inheritance diagram for visBase::Coordinates:
[legend]

## Public Member Functions
int | addPos (const Coord3 &)
void | copyFrom (const Coordinates &)
void | dirty () const
const char * | getClassName () const override
const visBase::Transformation * | getDisplayTransformation () const override
Coord3 | getPos (int, bool scenespace=false) const
void | insertPos (int, const Coord3 &)
bool | isDefined (int) const
bool | isEmpty () const
int | nextID (int previd) const
osg::Array * | osgArray ()
const osg::Array * | osgArray () const
void | removeAfter (int)
void | removePos (int, bool keepidxafter=true)
void | setAllPositions (const Coord3 &pos, int sz, int start)
void | setAllZ (const float *, int sz, bool dotransf)
void | setDisplayTransformation (const visBase::Transformation *) override
void | setEmpty ()
void | setPos (int, const Coord3 &)
void | setPositions (const Coord3 *, int sz, int start, bool scenespace=false)
void | setPositions (const TypeSet< Coord3 > &)
int | size (bool includedelete=false) const
Public Member Functions inherited from visBase::DataObject
template<class T >
T * | addNodeState (T *ns)
void | deSelect () const
virtual NotifierAccess * | deSelection ()
void | enableTraversal (unsigned int mask, bool yn=true)
virtual const char * | errMsg () const
SoNode * | getInventorNode ()
const SoNode * | getInventorNode () const
BufferString | getName () const override
NodeState * | getNodeState (int idx)
virtual float | getPixelDensity () const
VisID | id () const
virtual bool | isOK () const
virtual bool | isOn () const
bool | isPickable (bool actively=true) const
virtual bool | isRightHandSystem () const
virtual bool | isSelected () const
bool | isTraversalEnabled (unsigned int mask) const
const OD::String & | name () const override
osg::Node * | osgNode (bool skipswitch=false)
const osg::Node * | osgNode (bool skipswitch=false) const
NodeState * | removeNodeState (NodeState *)
virtual bool | rightClickable () const
virtual NotifierAccess * | rightClicked ()
virtual const TypeSet< VisID > * | rightClickedPath () const
void | select () const
virtual bool | selectable () const
virtual NotifierAccess * | selection ()
bool | serialize (const char *filename, bool binary=false)
void | setID (const VisID &)
void | setName (const char *) override
void | setName (const uiString &uistr)
void | setPickable (bool actively, bool passively=true)
virtual void | setPixelDensity (float dpi)
virtual void | setRightHandSystem (bool yn)
void | setUiName (const uiString &)
virtual bool | turnOn (bool yn)
uiString | uiName () const
void | updateSel () const
Public Member Functions inherited from SharedObject
| SharedObject (const char *nm=nullptr)
Public Member Functions inherited from NamedCallBacker
| NamedCallBacker (const char *nm=nullptr)
| NamedCallBacker (const NamedCallBacker &)=delete
| ~NamedCallBacker ()
virtual Notifier< NamedCallBacker > & | objectToBeDeleted () const
NamedCallBacker & | operator= (const NamedCallBacker &)=delete
bool | operator== (const NamedCallBacker &oth) const
bool | operator== (const NamedObject &oth) const
Public Member Functions inherited from CallBacker
| CallBacker ()
| CallBacker (const CallBacker &)
virtual | ~CallBacker ()
bool | attachCB (const NotifierAccess &, const CallBack &, bool onlyifnew=false) const
bool | attachCB (const NotifierAccess *notif, const CallBack &cb, bool onlyifnew=false) const
void | detachAllNotifiers () const
| Call from the destructor of your inherited object.
void | detachCB (const NotifierAccess &, const CallBack &) const
void | detachCB (const NotifierAccess *notif, const CallBack &cb) const
virtual bool | isCapsule () const
bool | isNotifierAttached (const NotifierAccess *) const
| Only for debugging purposes, don't use.
CallBacker & | operator= (const CallBacker &)=delete
void | stopReceivingNotifications () const
virtual CallBacker * | trueCaller ()
Public Member Functions inherited from NamedObject
| NamedObject (const char *nm=nullptr)
| NamedObject (const NamedObject &oth)
virtual | ~NamedObject ()
bool | getNameFromPar (const IOPar &)
const name_type & | name () const override
NamedObject & | operator= (const NamedObject &)
bool | operator== (const NamedObject &oth) const
Public Member Functions inherited from ObjectWithName
virtual | ~ObjectWithName ()
bool | hasName (const char *nm) const
bool | hasName (const name_type &nm) const
void | putNameInPar (IOPar &) const
Public Member Functions inherited from RefCount::Referenced
void | addObserver (WeakPtrBase *obs)
| Not for normal use. May become private.
int | nrRefs () const
| Only for expert use.
void | ref () const
bool | refIfReffed () const
| Don't use in production, for debugging.
void | removeObserver (WeakPtrBase *obs)
| Not for normal use. May become private.
bool | tryRef () const
| Not for normal use. May become private.
void | unRef () const
void | unRefNoDelete () const

## Static Public Member Functions
static RefMan< Coordinates > | create ()
static const char * | getStaticClassName ()
static void | initClass ()
static const char * | sFactoryKeyword ()
Static Public Member Functions inherited from visBase::DataObject
static osgViewer::CompositeViewer * | getCommonViewer ()
static float | getDefaultPixelDensity ()
static VisID | getID (const osg::Node *)
static bool | isVisualizationThread ()
static void | requestSingleRedraw ()
static void | setCommonViewer (osgViewer::CompositeViewer *)
static void | setDefaultPixelDensity (float)
static void | setVisualizationThread (const void *)
| Call only once from initialization.
Static Public Member Functions inherited from SharedObject
static Notifier< SharedObject > & | instanceCreated ()
Static Public Member Functions inherited from CallBacker
static void | createReceiverForCurrentThread ()
static void | removeReceiverForCurrentThread ()
Static Public Member Functions inherited from RefCount::Referenced
static bool | isSane (const Referenced *)

## Public Attributes
Notifier< Coordinates > | change

## Protected Member Functions
| ~Coordinates ()
int | arraySize () const
int | getFreeIdx ()
void | getPositions (TypeSet< Coord3 > &) const
void | setPosWithoutLock (int, const Coord3 &, bool scenespace)
Protected Member Functions inherited from visBase::DataObject
| DataObject ()
| ~DataObject ()
void | doAddNodeState (NodeState *)
virtual osg::StateSet * | getStateSet ()
template<class T >
T * | setOsgNode (T *t)
| Must be called during construction.
virtual void | triggerDeSel ()
virtual void | triggerRightClick (const EventInfo *=nullptr)
virtual void | triggerSel ()
void | updateNodemask ()
Protected Member Functions inherited from SharedObject
| ~SharedObject ()
Protected Member Functions inherited from NamedCallBacker
void | sendDelNotif () const
Protected Member Functions inherited from RefCount::Referenced
| Referenced ()
| Referenced (const Referenced &)
virtual | ~Referenced ()
Referenced & | operator= (const Referenced &)

## Protected Attributes
Threads::Mutex | mutex_
osg::Array * | osgcoords_
ConstRefMan< visBase::Transformation > | transformation_
TypeSet< int > | unusedcoords_
Protected Attributes inherited from NamedCallBacker
Threads::Atomic< bool > | delalreadytriggered_
Notifier< NamedCallBacker > | delnotif_
Protected Attributes inherited from NamedObject
BufferString | name_

## Private Member Functions
| Coordinates ()
| mOD_DisableCopy (Coordinates)

## Static Private Member Functions
static visBase::DataObject * | createInternal ()

## Friends
class | CoordinatesBuilder
class | CoordListAdapter
class | SetOrGetCoordinates

## Additional Inherited Members
Public Types inherited from ObjectWithName
typedef OD::String | name_type

## Detailed Description

A set of coordinates. The coordinates will be transformed by the transformation before given to Coin, and transformed back when doing a getPos.

Note
  The object will not react to changes in the transformation when it is set

<>

## Constructor & Destructor Documentation

## ◆ Coordinates()

visBase::Coordinates::Coordinates | ( |  | ) |
| private

## ◆ ~Coordinates()

visBase::Coordinates::~Coordinates | ( |  | ) |
| protected

## Member Function Documentation

## ◆ addPos()

int visBase::Coordinates::addPos | ( | const Coord3 & |  | ) |

## ◆ arraySize()

int visBase::Coordinates::arraySize | ( |  | ) | const
| protected

## ◆ copyFrom()

void visBase::Coordinates::copyFrom | ( | const Coordinates & |  | ) |

## ◆ create()

static RefMan< Coordinates > visBase::Coordinates::create | ( |  | ) |
| static

## ◆ createInternal()

static visBase::DataObject * visBase::Coordinates::createInternal | ( |  | ) |
| inline static private

## ◆ dirty()

void visBase::Coordinates::dirty | ( |  | ) | const

## ◆ getClassName()

const char * visBase::Coordinates::getClassName | ( |  | ) | const
| override virtual

Reimplemented from visBase::DataObject.

## ◆ getDisplayTransformation()

const visBase::Transformation * visBase::Coordinates::getDisplayTransformation | ( |  | ) | const
| override virtual

All positions going from the outside world to the vis should be transformed with this transform. This enables us to have different coord-systems outside OI, e.g. we can use UTM coords outside the vis without loosing precision in the vis.

Reimplemented from visBase::DataObject.

## ◆ getFreeIdx()

int visBase::Coordinates::getFreeIdx | ( |  | ) |
| protected

Object should be locked when calling

## ◆ getPos()

Coord3 visBase::Coordinates::getPos | ( | int | ,
|  | bool | scenespace = false ) const

## ◆ getPositions()

void visBase::Coordinates::getPositions | ( | TypeSet< Coord3 > & |  | ) | const
| protected

## ◆ getStaticClassName()

static const char * visBase::Coordinates::getStaticClassName | ( |  | ) |
| static

## ◆ initClass()

static void visBase::Coordinates::initClass | ( |  | ) |
| static

## ◆ insertPos()

void visBase::Coordinates::insertPos | ( | int | ,
|  | const Coord3 & | )

## ◆ isDefined()

bool visBase::Coordinates::isDefined | ( | int |  | ) | const

## ◆ isEmpty()

bool visBase::Coordinates::isEmpty | ( |  | ) | const
| inline

## ◆ mOD_DisableCopy()

visBase::Coordinates::mOD_DisableCopy | ( | Coordinates |  | ) |
| private

## ◆ nextID()

int visBase::Coordinates::nextID | ( | int | previd | ) | const

If previd == -1, first id is returned. If -1 is returned, no more id's are available.

## ◆ osgArray() [1/2]

osg::Array * visBase::Coordinates::osgArray | ( |  | ) |
| inline

## ◆ osgArray() [2/2]

const osg::Array * visBase::Coordinates::osgArray | ( |  | ) | const
| inline

## ◆ removeAfter()

void visBase::Coordinates::removeAfter | ( | int |  | ) |

## ◆ removePos()

void visBase::Coordinates::removePos | ( | int | ,
|  | bool | keepidxafter = true )

## ◆ setAllPositions()

void visBase::Coordinates::setAllPositions | ( | const Coord3 & | pos,
|  | int | sz,
|  | int | start )

## ◆ setAllZ()

void visBase::Coordinates::setAllZ | ( | const float * | ,
|  | int | sz,
|  | bool | dotransf )

## ◆ setDisplayTransformation()

void visBase::Coordinates::setDisplayTransformation | ( | const visBase::Transformation * |  | ) |
| override virtual

Note
  All existing coords will be recalculated back from the old transformation and transformed by the new one.

Reimplemented from visBase::DataObject.

## ◆ setEmpty()

void visBase::Coordinates::setEmpty | ( |  | ) |

## ◆ setPos()

void visBase::Coordinates::setPos | ( | int | ,
|  | const Coord3 & | )

## ◆ setPositions() [1/2]

void visBase::Coordinates::setPositions | ( | const Coord3 * | ,
|  | int | sz,
|  | int | start,
|  | bool | scenespace = false )

## ◆ setPositions() [2/2]

void visBase::Coordinates::setPositions | ( | const TypeSet< Coord3 > & |  | ) |

## ◆ setPosWithoutLock()

void visBase::Coordinates::setPosWithoutLock | ( | int | ,
|  | const Coord3 & | ,
|  | bool | scenespace )
| protected

Object should be locked when calling

## ◆ sFactoryKeyword()

static const char * visBase::Coordinates::sFactoryKeyword | ( |  | ) |
| static

## ◆ size()

int visBase::Coordinates::size | ( | bool | includedelete = false | ) | const

## Friends And Related Symbol Documentation

## ◆ CoordinatesBuilder

friend class CoordinatesBuilder
| friend

## ◆ CoordListAdapter

friend class CoordListAdapter
| friend

## ◆ SetOrGetCoordinates

friend class SetOrGetCoordinates
| friend

## Member Data Documentation

## ◆ change

Notifier<Coordinates> visBase::Coordinates::change

## ◆ mutex_

Threads::Mutex visBase::Coordinates::mutex_
| mutable protected

## ◆ osgcoords_

osg::Array* visBase::Coordinates::osgcoords_
| protected

## ◆ transformation_

ConstRefMan< visBase::Transformation > visBase::Coordinates::transformation_
| protected

## ◆ unusedcoords_

TypeSet<int> visBase::Coordinates::unusedcoords_
| protected

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025